<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>QuorumStats.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">QuorumStats.java</span></div><h1>QuorumStats.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

public class QuorumStats {
    private final Provider provider;
    
    public interface Provider {
        static public final String UNKNOWN_STATE = &quot;unknown&quot;;
        static public final String LOOKING_STATE = &quot;leaderelection&quot;;
        static public final String LEADING_STATE = &quot;leading&quot;;
        static public final String FOLLOWING_STATE = &quot;following&quot;;
        static public final String OBSERVING_STATE = &quot;observing&quot;;
        public String[] getQuorumPeers();
        public String getServerState();
    }
    
<span class="fc" id="L34">    protected QuorumStats(Provider provider) {</span>
<span class="fc" id="L35">        this.provider = provider;</span>
<span class="fc" id="L36">    }</span>
    
    public String getServerState(){
<span class="nc" id="L39">        return provider.getServerState();</span>
    }
    
    public String[] getQuorumPeers(){
<span class="nc" id="L43">        return provider.getQuorumPeers();</span>
    }

    @Override
    public String toString(){
<span class="nc" id="L48">        StringBuilder sb=new StringBuilder(super.toString());</span>
<span class="nc" id="L49">        String state=getServerState();</span>
<span class="nc bnc" id="L50" title="All 2 branches missed.">        if(state.equals(Provider.LEADING_STATE)){</span>
<span class="nc" id="L51">            sb.append(&quot;Followers:&quot;);</span>
<span class="nc bnc" id="L52" title="All 2 branches missed.">            for(String f: getQuorumPeers()){</span>
<span class="nc" id="L53">                sb.append(&quot; &quot;).append(f);</span>
            }
<span class="nc" id="L55">            sb.append(&quot;\n&quot;);            </span>
<span class="nc bnc" id="L56" title="All 2 branches missed.">        }else if(state.equals(Provider.FOLLOWING_STATE) </span>
<span class="nc bnc" id="L57" title="All 2 branches missed.">                || state.equals(Provider.OBSERVING_STATE)){</span>
<span class="nc" id="L58">            sb.append(&quot;Leader: &quot;);</span>
<span class="nc" id="L59">            String[] ldr=getQuorumPeers();</span>
<span class="nc bnc" id="L60" title="All 2 branches missed.">            if(ldr.length&gt;0)</span>
<span class="nc" id="L61">                sb.append(ldr[0]);</span>
            else
<span class="nc" id="L63">                sb.append(&quot;not connected&quot;);</span>
<span class="nc" id="L64">            sb.append(&quot;\n&quot;);</span>
        }
<span class="nc" id="L66">        return sb.toString();</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>